package com.sun.security.auth.callback;

import java.util.Iterator;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.Box;
import javax.swing.JPasswordField;
import javax.swing.JLabel;
import javax.security.auth.callback.UnsupportedCallbackException;
import javax.security.auth.callback.ConfirmationCallback;
import javax.security.auth.callback.PasswordCallback;
import javax.security.auth.callback.NameCallback;
import javax.security.auth.callback.TextOutputCallback;
import java.util.ArrayList;
import javax.security.auth.callback.Callback;
import java.awt.Component;
import jdk.Exported;
import javax.security.auth.callback.CallbackHandler;

@Exported(false)
@Deprecated
public class DialogCallbackHandler implements CallbackHandler
{
    private Component parentComponent;
    private static final int JPasswordFieldLen = 8;
    private static final int JTextFieldLen = 8;
    
    public DialogCallbackHandler() {
    }
    
    public DialogCallbackHandler(Component parentComponent) {
        this.parentComponent = parentComponent;
    }
    
    @Override
    public void handle(Callback[] array) throws UnsupportedCallbackException {
        ArrayList list = new ArrayList(3);
        ArrayList list2 = new ArrayList(2);
        DialogCallbackHandler.ConfirmationInfo confirmationInfo = new DialogCallbackHandler.ConfirmationInfo();
        for (int i = 0; i < array.length; ++i) {
            if ((array[i] instanceof TextOutputCallback)) {
                TextOutputCallback textOutputCallback = (TextOutputCallback)array[i];
                switch (textOutputCallback.getMessageType()) {
                    case 0: {
                        confirmationInfo.messageType = 1;
                        break;
                    }
                    case 1: {
                        confirmationInfo.messageType = 2;
                        break;
                    }
                    case 2: {
                        confirmationInfo.messageType = 0;
                        break;
                    }
                    default: {
                        throw new UnsupportedCallbackException(array[i], "Unrecognized message type");
                    }
                }
                list.add(textOutputCallback.getMessage());
            }
            else if ((array[i] instanceof NameCallback)) {
                final NameCallback nameCallback = (NameCallback)array[i];
                JLabel comp3 = new JLabel(nameCallback.getPrompt());
                final Object comp4 = new JTextField(8);
                String defaultName = nameCallback.getDefaultName();
                if (defaultName != null) {
                    comp4.setText(defaultName);
                }
                Box horizontalBox2 = Box.createHorizontalBox();
                horizontalBox2.add(comp3);
                horizontalBox2.add(comp4);
                list.add(horizontalBox2);
                list2.add(new DialogCallbackHandler.Action() {
                    @Override
                    public void perform() {
                        nameCallback.setName(comp4.getText());
                    }
                });
            }
            else if ((array[i] instanceof PasswordCallback)) {
                final PasswordCallback passwordCallback = (PasswordCallback)array[i];
                JLabel comp = new JLabel(passwordCallback.getPrompt());
                final Object comp2 = new JPasswordField(8);
                if (!passwordCallback.isEchoOn()) {
                    comp2.setEchoChar('*');
                }
                Box horizontalBox = Box.createHorizontalBox();
                horizontalBox.add(comp);
                horizontalBox.add(comp2);
                list.add(horizontalBox);
                list2.add(new DialogCallbackHandler.Action() {
                    @Override
                    public void perform() {
                        passwordCallback.setPassword(comp2.getPassword());
                    }
                });
            }
            else if ((array[i] instanceof ConfirmationCallback)) {
                ConfirmationCallback callback = (ConfirmationCallback)array[i];
                confirmationInfo.setCallback(callback);
                if (callback.getPrompt() != null) {
                    list.add(callback.getPrompt());
                }
            }
            else {
                throw new UnsupportedCallbackException(array[i], "Unrecognized Callback");
            }
        }
        int showOptionDialog = JOptionPane.showOptionDialog(this.parentComponent, list.toArray(), "Confirmation", confirmationInfo.optionType, confirmationInfo.messageType, null, confirmationInfo.options, confirmationInfo.initialValue);
        if (showOptionDialog == 0 || showOptionDialog == 0) {
            Iterator<Object> iterator = list2.iterator();
            while (iterator.hasNext()) {
                ((DialogCallbackHandler.Action)iterator.next()).perform();
            }
        }
        confirmationInfo.handleResult(showOptionDialog);
    }
    
    private static class ConfirmationInfo
    {
        private int[] translations;
        int optionType;
        Object[] options;
        Object initialValue;
        int messageType;
        private ConfirmationCallback callback;
        
        private ConfirmationInfo() {
            this.optionType = 2;
            this.options = null;
            this.initialValue = null;
            this.messageType = 3;
        }
        
        void setCallback(ConfirmationCallback callback) throws UnsupportedCallbackException {
            this.callback = callback;
            int optionType = callback.getOptionType();
            switch (optionType) {
                case 0: {
                    this.optionType = 0;
                    this.translations = new int[] { 0, 0, 1, 1, -1, 1 };
                    break;
                }
                case 1: {
                    this.optionType = 1;
                    this.translations = new int[] { 0, 0, 1, 1, 2, 2, -1, 2 };
                    break;
                }
                case 2: {
                    this.optionType = 2;
                    this.translations = new int[] { 0, 3, 2, 2, -1, 2 };
                    break;
                }
                case -1: {
                    this.options = callback.getOptions();
                    this.translations = new int[] { -1, callback.getDefaultOption() };
                    break;
                }
                default: {
                    throw new UnsupportedCallbackException(callback, "Unrecognized option type: " + optionType);
                }
            }
            int messageType = callback.getMessageType();
            switch (messageType) {
                case 1: {
                    this.messageType = 2;
                    break;
                }
                case 2: {
                    this.messageType = 0;
                    break;
                }
                case 0: {
                    this.messageType = 1;
                    break;
                }
                default: {
                    throw new UnsupportedCallbackException(callback, "Unrecognized message type: " + messageType);
                }
            }
        }
        
        void handleResult(int selectedIndex) {
            if (this.callback == null) {
                return;
            }
            int i = 0;
            while (i < this.translations.length) {
                if (this.translations[i] == selectedIndex) {
                    selectedIndex = this.translations[i + 1];
                    break;
                }
                i += 2;
            }
            this.callback.setSelectedIndex(selectedIndex);
            return;
        }
    }
    
    private interface Action
    {
        public abstract void perform();
    }
}
